//
//  It is file 'cpath.hpp'
//
//  Copyright (C) 1992, 1993 Serge Pachkovsky, ps@che.nsk.su
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
class ContextPath {
    CharType	    queue[ MaxModelOrder + 1 ] ;
    int 	    last ;
    public:
		    ContextPath( void ) ;
    CharType	    operator []( int level ) const ;
    void	    operator <<( CharType ) ;
    } ;

inline
ContextPath::ContextPath( void )
{
    int 	i ;

for( i = 0 ; i < MaxModelOrder + 1 ; i++ )
    queue[ i ] = CharType( 0 ) ;
last = 0 ;
}

inline CharType
ContextPath::operator []( int level ) const
{
if( ( level += last ) >= MaxModelOrder + 1 )
    level -= MaxModelOrder + 1 ;
return queue[ level ] ;
}

inline void
ContextPath::operator <<( CharType c )
{
if( --last < 0 )
    last += MaxModelOrder + 1 ;
queue[ last ] = c ;
}

