//
//  It is file 'gcc_upd.cc'
//
//  Copyright (C) 1992, 1993 Serge Pachkovsky, ps@che.nsk.su
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#include "stdinc.hpp"
#ifdef MSDOS
#include <dos.h>
#endif

long tell( int handle )
{
return lseek( handle, 0L, SEEK_CUR ) ;
}

static char *
print_value( unsigned value, char *string, int radix )
{
if( value > radix )
    string = print_value( value / radix, string, radix ) ;
string[0] = "0123456789ABCDEF"[ value % radix ] ;
string[1] = 0 ;
return string + 1 ;
}

char *
itoa( int value, char *string, int radix )
{
print_value( (unsigned) value, string, radix ) ;
return string ;
}

int
mkdir( char *name )
{
return mkdir( name, 0 ) ;
}

long
filelength( int handle )
{
    long    old  = tell( handle ) ;
    long    size = lseek( handle, 0, SEEK_END ) ;

if( size == -1 ){
    perror( "filelength failed" ) ;
    exit( -1 ) ;
    }
if( lseek( handle, old, SEEK_SET ) == -1 ){
    perror( "filelength: cant restore old position\n" ) ;
    exit( -1 ) ;
    }
#ifdef DEBUG
cerr << "filelenght: got file length of " << size << " bytes\n" ;
#endif
return size ;
}

#if ! ( defined( __UTIME_H__ ) || defined( _H_UTIME ) )
int
utime( const char *name, struct utimbuf * filetime )
{
//cerr << "utime( " << name << ", {" << filetime->actime << ", " << filetime->modtime << ")\n" ;

    int 	    handle = open( name, O_RDONLY | O_BINARY ) ;

if( handle == -1 ) return -1 ;

    struct tm *     tmbuf  = localtime( &filetime->modtime ) ;
    struct ftime    dos_filetime ;

dos_filetime.ft_tsec  = tmbuf->tm_sec / 2 ;
dos_filetime.ft_min   = tmbuf->tm_min ;
dos_filetime.ft_hour  = tmbuf->tm_hour ;
dos_filetime.ft_day   = tmbuf->tm_mday ;
dos_filetime.ft_month = tmbuf->tm_mon  + 1 ;
dos_filetime.ft_year  = tmbuf->tm_year - 80 ;
if( setftime( handle, &dos_filetime ) != 0 ){
    close( handle ) ;
    return -1 ;
    }
close( handle ) ;
return 0 ;
}
#endif
